package philosophers;

public class Chopstick {
	Object holder;
	private int no;
	
	public Chopstick(int n) {
		no = n;
	}
	
	public int getNumber() {
		return no;
	}
	
	public boolean isHeld() {
		return holder != null;
	}
	
	public boolean take(Object h) {
		synchronized(this) {
			if (holder == null) {			
				holder = h;
				System.out.println("Chopstick " + toString() + " picked up by " + holder);
				return true;
			} else {
				return false;
			}
		}
	}
	
	public void release() {
		synchronized(this) {
			if (holder != null) {
				System.out.println("Chopstick " + toString() + " released by " + holder);
				holder = null;
			}
			notify();
		}
	}
	
	public String toString() {
		return Integer.toString(no);
	}
}
