package philosophers;

public class OrderedPhilosopher extends Philosopher {
	public OrderedPhilosopher(String name, Chopstick left, Chopstick right) {
		super(name, left, right);
	}
	
	public void run() {
		// Instead of grabbing left then right, always grap the lower numbered chopstick
		Chopstick first, second;
		if (left.getNumber() < right.getNumber()) {
			first = left;
			second = right;
		} else {
			first = right;
			second = left;
		}
		
		while (!first.take(this)) { 
			philosophize();
		}
		
		philosophize();
		
		while (!second.take(this)) {
			philosophize();
		}
		
		eat ();
		first.release();
		second.release();
		System.out.println(name + " is finished.");
	}
}
